#include <avr/io.h>
#include <util/delay.h>
#include "main.h"
#include "lcd_drv.h"
#include <stdlib.h>
#include <avr/eeprom.h>

#define F_CPU 8000000UL
uint16_t eeFooWord EEMEM;

// ***** Tastenentprellung **********************************************************
inline uint8_t debounce(volatile uint8_t *port, uint8_t pin){ //Tastenentprellung
    if (!(*port & (1 << pin))) //Wenn Taste gedrckt wurde,...
    {
        _delay_ms(20); //...dann warte 100ms
        if (*port & (1 << pin)) //Wenn Taste nicht mehr gedrck wird,...
        {
            _delay_ms(20); //...dann warte 100ms
            return 1;
        }
    }
    return 0;
}


// ***** Hauptroutine **************************************************************
int main(void){
	DDRD = 0xff; //PortD als Ausgang
	DDRD  &= ~(1<<DDD4);  // PD4 als Eingang
	PORTD |= (1<<PD4);    // internen Pull-Up an PD4 aktivieren
	uint16_t count;
	char count_str[20];
	count = eeprom_read_word(&eeFooWord);
	lcd_init();
	lcd_pos(0,0);
	lcd_text((u8*)"Setzen ?");
	long i=0;
	while(i<1000000)
	{
		if(debounce(&PIND,PIND4))
		{
			count=0;
			eeprom_write_word(&eeFooWord, count);
			i=1000000;
		}
		i++;
	}
	lcd_init();
	while(1) //Hauptschleife
	{
		itoa(count,count_str,10);
		lcd_pos(0,0);
		lcd_text((u8*)count_str);
		if(debounce(&PIND,PIND4))
		{
			lcd_init();
			count++;
			eeprom_write_word(&eeFooWord, count);
		}
	}
}
